/// @cond EO_CXX_EO_IMPL

inline void elm::ctxpopup_item::init(Evas_Smart_Cb func_, const void * data_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_ctxpopup_item_init(func_, data_));
}

inline ::elm::widget_item elm::ctxpopup_item::prev_get() const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_ctxpopup_item_prev_get());
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item elm::ctxpopup_item::next_get() const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_ctxpopup_item_next_get());
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::ctxpopup_item::init(Evas_Smart_Cb func_, const void * data_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_ctxpopup_item_init(func_, data_));
}

inline ::elm::widget_item eo_cxx::elm::ctxpopup_item::prev_get() const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_ctxpopup_item_prev_get());
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item eo_cxx::elm::ctxpopup_item::next_get() const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_ctxpopup_item_next_get());
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::eo_cxx::elm::ctxpopup_item::operator ::elm::ctxpopup_item() const
{
   return *static_cast<::elm::ctxpopup_item const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm::ctxpopup_item::operator ::elm::ctxpopup_item&()
{
   return *static_cast<::elm::ctxpopup_item*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm::ctxpopup_item::operator ::elm::ctxpopup_item const&() const
{
   return *static_cast<::elm::ctxpopup_item const*>(static_cast<void const*>(this));
}

template <typename T>
void elm_ctxpopup_item_init_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Smart_Cb func_, const void * data_)
{
   try
      {
         static_cast<T*>(self->this_)->init(func_, data_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
::elm::widget_item elm_ctxpopup_item_prev_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->prev_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
::elm::widget_item elm_ctxpopup_item_next_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->next_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm::ctxpopup_item >
{
   template <typename T>
   struct type
         : virtual operations< ::elm::widget_item >::template type<T>
   {
      virtual void init(Evas_Smart_Cb func_, const void * data_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_ctxpopup_item_init(func_, data_));
      }

      virtual ::elm::widget_item prev_get()
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_ctxpopup_item_prev_get());
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual ::elm::widget_item next_get()
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_ctxpopup_item_next_get());
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

   };
};


template<>
struct operation_description_class_size< ::elm::ctxpopup_item >
{
   static constexpr int value = 
#if defined(CTXPOPUP_ITEM_PROTECTED) && defined(CTXPOPUP_ITEM_BETA)
      3
#elif defined(CTXPOPUP_ITEM_PROTECTED)
      3
#elif defined(CTXPOPUP_ITEM_BETA)
      3
#else
      3
#endif
      + operation_description_class_size<::elm::widget_item >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm::ctxpopup_item>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
   ops[i].func = reinterpret_cast<void*>(& ::elm_ctxpopup_item_init_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_ctxpopup_item_init);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_ctxpopup_item_prev_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_ctxpopup_item_prev_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_ctxpopup_item_next_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_ctxpopup_item_next_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   initialize_operation_description<T>(::efl::eo::detail::tag<::elm::widget_item>(), &ops[operation_description_class_size< ::elm::ctxpopup_item >::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm::ctxpopup_item>)
{
   return (ELM_CTXPOPUP_ITEM_CLASS);
}

} } }

/// @endcond

